/****************************************************************************
*                                                                           *
*  OpenNI 1.x Alpha                                                         *
*  Copyright (C) 2011 PrimeSense Ltd.                                       *
*                                                                           *
*  This file is part of OpenNI.                                             *
*                                                                           *
*  OpenNI is free software: you can redistribute it and/or modify           *
*  it under the terms of the GNU Lesser General Public License as published *
*  by the Free Software Foundation, either version 3 of the License, or     *
*  (at your option) any later version.                                      *
*                                                                           *
*  OpenNI is distributed in the hope that it will be useful,                *
*  but WITHOUT ANY WARRANTY; without even the implied warranty of           *
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             *
*  GNU Lesser General Public License for more details.                      *
*                                                                           *
*  You should have received a copy of the GNU Lesser General Public License *
*  along with OpenNI. If not, see <http://www.gnu.org/licenses/>.           *
*                                                                           *
****************************************************************************/
package org.OpenNI;

public abstract class ObjectWrapper
{
	public ObjectWrapper(long ptr)
	{
		if (ptr == 0)
		{
			throw new NullPointerException("JavaWrapper: Trying to wrap a null object!");
		}
		this.ptr = ptr;
	}
	
	public long toNative()
	{
		return this.ptr;
	}

	protected void finalize()
	{
		dispose();
	}
	
	public void dispose()
	{
		if (this.ptr != 0)
		{
			freeObject(this.ptr);
			this.ptr = 0;
		}
	}
	
	protected abstract void freeObject(long ptr);
	
	private long ptr;
}
